
from django.http import JsonResponse
from django.http import HttpResponse
import requests
from hashlib import sha1
import json
import base64
from Crypto import Random

from Crypto.Cipher import AES

from view import views


def subMerchantDelcareStr(request):
    
    request.encoding='utf-8'

    
    dic = {}
    
    dic.setdefault("merchantId", request.POST['merchantId'])
    
    dic.setdefault("operationType", request.POST['operationType'])
    dic.setdefault("requestId", request.POST['requestId'])
    dic.setdefault("subMerchantId", request.POST['subMerchantId'])
    
    dic.setdefault("signedName", request.POST['signedName'])
    
    
    dic.setdefault("email", request.POST['email'])
    
    dic.setdefault("phone", request.POST['phone'])
    
    dic.setdefault("businessScope", request.POST['businessScope'])
    
    
    dic.setdefault("authUserId", request.POST['authUserId'])
    
    dic.setdefault("authEnterpriseId", request.POST['authEnterpriseId'])
    
    dic.setdefault("hasAgreeProtocol", request.POST['hasAgreeProtocol'])

    
    
    declarationSubMerchantCertificate = {}
    declarationSubMerchantCertificate.setdefault("businessLicensePath", request.POST['businessLicensePath'])
    
    declarationSubMerchantCertificate.setdefault("effectiveDateStart", request.POST['effectiveDateStart'])
    
    declarationSubMerchantCertificate.setdefault("effectiveDateEnd", request.POST['effectiveDateEnd'])
    
    declarationSubMerchantCertificate.setdefault("idNo", request.POST['idNo'])
    
    declarationSubMerchantCertificate.setdefault("settleBankCardPath", request.POST['settleBankCardPath'])
    
    declarationSubMerchantCertificate.setdefault("idType", request.POST['idType'])
    
    declarationSubMerchantCertificate.setdefault("legalIdCardConsPath", request.POST['legalIdCardConsPath'])
    
    declarationSubMerchantCertificate.setdefault("legalIdCardProsPath", request.POST['legalIdCardProsPath'])
    
    declarationSubMerchantCertificate.setdefault("name", request.POST['name'])
    
    declarationSubMerchantCertificate.setdefault("openAccountPath", request.POST['openAccountPath'])
    
    declarationSubMerchantCertificate.setdefault("otherCerPath", request.POST['otherCerPath'])
    
    declarationSubMerchantCertificate.setdefault("registerRole", request.POST['registerRole'])
    
    
    dic.setdefault("declarationSubMerchantCertificate",declarationSubMerchantCertificate)

    
    declarationSubMerchantRiskDocs = []
    
    REGISTER_AMOUNT = {}
    STAFF_SIZE={}
    OFFICE_SPACE={}
    
    
    REGISTER_AMOUNT.setdefault("answer", request.POST['REGISTER_AMOUNT'])
    STAFF_SIZE.setdefault("answer", request.POST['STAFF_SIZE'])
    OFFICE_SPACE.setdefault("answer", request.POST['OFFICE_SPACE'])
    
    REGISTER_AMOUNT.setdefault("docCode", "REGISTER_AMOUNT")
    STAFF_SIZE.setdefault("docCode", "STAFF_SIZE")
    OFFICE_SPACE.setdefault("docCode","OFFICE_SPACE")
    
    
    declarationSubMerchantRiskDocs.append(REGISTER_AMOUNT)
    declarationSubMerchantRiskDocs.append(STAFF_SIZE)
    declarationSubMerchantRiskDocs.append(OFFICE_SPACE)
    
    dic.setdefault("declarationSubMerchantRiskDocs",declarationSubMerchantRiskDocs)
    
    print("declarationSubMerchantRiskDocs:",declarationSubMerchantRiskDocs)
    
    print("dic------------------------:",dic)
    
    dicstr = views.get_sort(dic)
    
    
    psw=sha1()
    
    print(dicstr)
    psw.update(dicstr.encode('utf8'))
    
    #spwdSha2 = psw.hexdigest();
    spwdSha1=psw.digest()
    print('spwdSha1:-------',spwdSha1)
    
    HMAC0 = views.gen_sign(spwdSha1)
    
    dic.setdefault("hmac", HMAC0.decode())
    
    
    #dichmac = dict(sorted(dic.items(),reverse=False))
    
    dicjson = dict(sorted(dic.items(),reverse=False))
    
    print("dicjson---------------:",dicjson)
    
    random = views.gen_random()
    
    print('random-------',random.encode())
    
    encrypted_text = views.aes_cipher(random,json.dumps(dicjson))
    
    print (len(encrypted_text),encrypted_text)
    
    aesRsa = views.gen_encrypt(random)
    
    
    print('aesrsa:-----------------------------',aesRsa)
    
    str = aesRsa.decode()
    
    print(str)
    #aesRsastr = str(base64.urlsafe_b64encode(aesRsa),'utf8')
    
    url='https://apis.5upay.com/declaration/submerchant/subMerchantDeclare'
    headers1 = {'Content-Type': "application/vnd.5upay-v3.0+json",'encryptKey':str,'merchantId':request.POST['merchantId'],'requestId': request.POST['requestId']}
    
    response = requests.post(url, data = encrypted_text, headers = headers1)
    
    
    head = response.headers
    print(head)
    
    x = requests.structures.CaseInsensitiveDict(head)
    js = dict(x)
    
    #print(js)
    
    encryptKey = js.get("encryptKey")
    
    if encryptKey != None :
    
        encryptKey = views.gen_decrypt(encryptKey)
        
        print('encryptKey',encryptKey)
        
        
        result = response.text
    
        print(result)
        json56 = json.loads(result)
        
        encryptKeyjson = json56['data']
       
        print('encryptKeyjson',encryptKeyjson)
    
        aes_de = AES.new(encryptKey, AES.MODE_ECB) 
        
        decrypted_text = (aes_de.decrypt(base64.decodebytes(bytes(encryptKeyjson, encoding='utf8'))).rstrip(b'\0')).decode()
        decrypted_text = decrypted_text[:-ord(decrypted_text[-1])]
        
        print (decrypted_text)
        decryptdic = eval(decrypted_text)
        
        status = decryptdic.get("status")
        hmac = decryptdic.get("hmac")
        
        decryptdicjson = dict(sorted(decryptdic.items(),reverse=False))
     
        if hmac != None:
            
              
            hamcstr = decryptdicjson.pop("hmac")
            
            print ('hamcstr',hamcstr)
            decryptdicj = views.get_sort(decryptdicjson)
            print(decryptdicj)      
            shade=sha1()
        
            shade.update(decryptdicj.encode('utf8'))
        
            destrSha1=shade.digest()
            
            strsss = views.verify_sign(destrSha1,hamcstr)
            
            print ('strsss',strsss)
            print ('status',status)
            if strsss == True :
              
                return HttpResponse(decrypted_text)
    
            else :
                
                print (decrypted_text)
                        
                return JsonResponse({'cer verify_sign fail:':decrypted_text})
        else :
            return HttpResponse(decrypted_text)
    else : 
        
        return HttpResponse("get header fail")