"""SubMerchantDeclare URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/2.2/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.contrib import admin
from django.urls import path
from view import views
from view import billingOrder
from view import settlementOrder

from view import settlementRuleQuery
from view import subMerchantDelcare
from view import subMerchantQuery

urlpatterns = [
    path('index/', views.index),
    
    path('billingOrder/', views.billingOrder),
    path('settlementOrder/', views.settlementOrder),
    path('settlementRuleQuery/', views.settlementRuleQuery),
    path('subMerchantDeclare/', views.subMerchantDeclare),
    path('subMerchantQuery/', views.subMerchantQuery),
    path('billingOrderStr/', billingOrder.billingOrderStr),
    
    path('settlementOrderStr/', settlementOrder.settlementOrderStr),
    path('settlementRuleQueryStr/', settlementRuleQuery.settlementRuleQueryStr),
    path('subMerchantDelcareStr/', subMerchantDelcare.subMerchantDelcareStr),
    path('subMerchantQueryStr/', subMerchantQuery.subMerchantQueryStr),
]
